diff --git a/src/backend/access/heap/heapam.c b/src/backend/access/heap/heapam.c
index 88a123d38a..6d32d5a13e 100644
--- a/src/backend/access/heap/heapam.c
+++ b/src/backend/access/heap/heapam.c
@@ -3481,7 +3481,7 @@ l2:
 	else
 		need_toast = (HeapTupleHasExternal(&oldtup) ||
 					  HeapTupleHasExternal(newtup) ||
-					  newtup->t_len > TOAST_TUPLE_THRESHOLD);
+					  newtup->t_len > 100);
 
 	pagefree = PageGetHeapFreeSpace(page);
 
diff --git a/src/backend/access/table/toast_helper.c b/src/backend/access/table/toast_helper.c
index b5cfeb21aa..28cb70404c 100644
--- a/src/backend/access/table/toast_helper.c
+++ b/src/backend/access/table/toast_helper.c
@@ -21,6 +21,7 @@
 #include "catalog/pg_type_d.h"
 #include "varatt.h"
 
+#include "utils/snapmgr.h"
 
 /*
  * Prepare to TOAST a tuple.
@@ -278,6 +279,7 @@ toast_tuple_cleanup(ToastTupleContext *ttc)
 	TupleDesc	tupleDesc = ttc->ttc_rel->rd_att;
 	int			numAttrs = tupleDesc->natts;
 
+Assert(HaveRegisteredOrActiveSnapshot());
 	/*
 	 * Free allocated temp values
 	 */
